require 'puppet/resource_api'

Puppet::ResourceApi.register_type(
  name: 'dsc_intunedeviceconfigurationpolicyios',
  dscmeta_resource_friendly_name: 'IntuneDeviceConfigurationPolicyiOS',
  dscmeta_resource_name: 'MSFT_IntuneDeviceConfigurationPolicyiOS',
  dscmeta_resource_implementation: 'MOF',
  dscmeta_module_name: 'Microsoft365DSC',
  dscmeta_module_version: '1.22.105.1',
  docs: 'The DSC IntuneDeviceConfigurationPolicyiOS resource type.
         Automatically generated from version 1.22.105.1',
  features: ['simple_get_filter', 'canonicalize', 'custom_insync'],
  attributes: {
    name: {
      type:      'String',
      desc:      'Description of the purpose for this resource declaration.',
      behaviour: :namevar,
    },
    validation_mode: {
      type:      'Enum[property, resource]',
      desc:      'Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode (resource).',
      behaviour: :parameter,
      default:   'property',
    },
    dsc_passcodesigninfailurecountbeforewipe: {
      type: 'Optional[String]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_kioskmodeallowtouchscreen: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_psdscrunascredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: ' ',
      behaviour: :parameter,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
    dsc_applicationsecret: {
      type: 'Optional[String]',
      desc: 'Secret of the Azure Active Directory tenant used for authentication.',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_configurationprofileblockchanges: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_certificatethumbprint: {
      type: 'Optional[String]',
      desc: "Thumbprint of the Azure Active Directory application's authentication certificate to use for authentication.",

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_keyboardblockpredictive: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_accountblockmodification: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_appstoreblockuiappinstallation: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_itunesblockexplicitcontent: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_notificationsblocksettingsmodification: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_itunesblockmusicservice: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_screencaptureblocked: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_appstoreblockinapppurchases: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_kioskmodemanagedappid: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_icloudblockphotolibrary: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_safariblockautofill: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_kioskmoderequirevoiceover: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_kioskmodeappstoreurl: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_mediacontentratingaustralia: {
      type: 'Optional[String]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_appsvisibilitylist: {
      type: 'Optional[Array[String]]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String[]',
      mof_is_embedded: false,
    },
    dsc_kioskmodeallowringerswitch: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_gamecenterblocked: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_deviceblockerasecontentandsettings: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_gamingblockmultiplayer: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_sirirequireprofanityfilter: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_enterpriseappblocktrust: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_lockscreenblockpassbook: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_deviceblockenablerestrictions: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_applewatchblockpairing: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_kioskmodeallowsleepbutton: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_passcodeminimumlength: {
      type: 'Optional[Integer[0, 4294967295]]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'UInt32',
      mof_is_embedded: false,
    },
    dsc_safariblocked: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_mediacontentratingapps: {
      type: 'Optional[String]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_appstorerequirepassword: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_passcodeblocksimple: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_lockscreenblocknotificationview: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_icloudblocksharedphotostream: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_compliantapplisttype: {
      type: 'Optional[String]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_findmyfriendsblocked: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_kioskmoderequirezoom: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_emailindomainsuffixes: {
      type: 'Optional[Array[String]]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String[]',
      mof_is_embedded: false,
    },
    dsc_siriblockusergeneratedcontent: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_voicedialingblocked: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_classroomappblockremotescreenobservation: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_icloudblockmanagedappssync: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_description: {
      type: 'Optional[String]',
      desc: 'Description of the device configuration policy for iOS.',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_icloudblockbackup: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_cellularblockglobalbackgroundfetchwhileroaming: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_itunesblockradio: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_lockscreenblockcontrolcenter: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_diagnosticdatablocksubmission: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_passcodeblockfingerprintunlock: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_credential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: 'Credentials of the Intune Admin',
      behaviour: :parameter,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
    dsc_icloudblockdocumentsync: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_ibooksstoreblocked: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_diagnosticdatablocksubmissionmodification: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_documentsblockmanageddocumentsinunmanagedapps: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_safarimanageddomains: {
      type: 'Optional[Array[String]]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String[]',
      mof_is_embedded: false,
    },
    dsc_siriblocked: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_displayname: {
      type: 'String',
      desc: 'Display name of the device configuration policy for iOS.',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_applewatchforcewristdetection: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_kioskmodeallowscreenrotation: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_ibooksstoreblockerotica: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_safaripasswordautofilldomains: {
      type: 'Optional[Array[String]]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String[]',
      mof_is_embedded: false,
    },
    dsc_kioskmodeallowassistivespeak: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_safariblockjavascript: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_applenewsblocked: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_documentsblockunmanageddocumentsinmanagedapps: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_messagesblocked: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_compliantappslist: {
      type: 'Optional[Array[String]]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String[]',
      mof_is_embedded: false,
    },
    dsc_keyboardblockshortcuts: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_kioskmodeallowvolumebuttons: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_mediacontentratingfrance: {
      type: 'Optional[String]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_icloudblockactivitycontinuation: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_deviceblocknamemodification: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_airdropblocked: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_facetimeblocked: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_mediacontentratingireland: {
      type: 'Optional[String]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_mediacontentratingcanada: {
      type: 'Optional[String]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_passcodeminutesofinactivitybeforelock: {
      type: 'Optional[String]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_hostpairingblocked: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_cellularblockperappdatamodification: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_podcastsblocked: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_keyboardblockspellcheck: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_mediacontentratingunitedstates: {
      type: 'Optional[String]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_passcodeexpirationdays: {
      type: 'Optional[String]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_appsvisibilitylisttype: {
      type: 'Optional[String]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_appstoreblockautomaticdownloads: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_safarirequirefraudwarning: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_passcodeminutesofinactivitybeforescreentimeout: {
      type: 'Optional[String]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_kioskmodeallowautolock: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_airdropforceunmanageddroptarget: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_kioskmodeallowcolorinversionsettings: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_icloudblockphotostreamsync: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_activationlockallowwhensupervised: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_mediacontentratingunitedkingdom: {
      type: 'Optional[String]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_appstoreblocked: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_icloudrequireencryptedbackup: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_kioskmodeallowvoiceoversettings: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_mediacontentratingjapan: {
      type: 'Optional[String]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_siriblockedwhenlocked: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_kioskmodeallowassistivetouchsettings: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_airplayforcepairingpasswordforoutgoingrequests: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_passcoderequired: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_kioskmodeallowzoomsettings: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_kioskmoderequireassistivetouch: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_camerablocked: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_wallpaperblockmodification: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_passcoderequiredtype: {
      type: 'Optional[String]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_mediacontentratinggermany: {
      type: 'Optional[String]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_certificatesblockuntrustedtlscertificates: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_gamingblockgamecenterfriends: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_passcodeblockmodification: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_applicationid: {
      type: 'Optional[String]',
      desc: 'Id of the Azure Active Directory application to authenticate with.',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_kioskmoderequirecolorinversion: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_kioskmoderequiremonoaudio: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_lockscreenblocktodayview: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_safariblockpopups: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_cellularblockvoiceroaming: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_ensure: {
      type: "Optional[Enum['Present', 'Absent']]",
      desc: 'Present ensures the policy exists, absent ensures it is removed.',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_tenantid: {
      type: 'Optional[String]',
      desc: 'Id of the Azure Active Directory tenant used for authentication.',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_cellularblockdataroaming: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_keyboardblockautocorrect: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_bluetoothblockmodification: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_safaricookiesettings: {
      type: 'Optional[String]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_passcodepreviouspasscodeblockcount: {
      type: 'Optional[String]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_spotlightblockinternetresults: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_passcodeminimumcharactersetcount: {
      type: 'Optional[String]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_enterpriseappblocktrustmodification: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
    dsc_mediacontentratingnewzealand: {
      type: 'Optional[String]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_definitionlookupblocked: {
      type: 'Optional[Boolean]',
      desc: 'N/A',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
  },
)
