<#
This example is used to test new resources and showcase the usage of new resources being worked on.
It is not meant to use as a production baseline.
#>

Configuration Example
{
    param(
        [Parameter(Mandatory = $true)]
        [PSCredential]
        $credsGlobalAdmin
    )
    Import-DscResource -ModuleName Microsoft365DSC

    node localhost
    {
        TeamsClientConfiguration 'TeamsClientConfiguration'
        {
            AllowBox                         = $True
            AllowDropBox                     = $True
            AllowEmailIntoChannel            = $True
            AllowGoogleDrive                 = $True
            AllowGuestUser                   = $True
            AllowOrganizationTab             = $True
            AllowResourceAccountSendMessage  = $True
            AllowScopedPeopleSearchandAccess = $False
            AllowShareFile                   = $True
            AllowSkypeBusinessInterop        = $True
            ContentPin                       = "RequiredOutsideScheduleMeeting"
            Identity                         = "Global"
            ResourceAccountContentAccess     = "NoAccess"
            Credential                       = $credsGlobalAdmin
        }
    }
}
