<#
This example is used to test new resources and showcase the usage of new resources being worked on.
It is not meant to use as a production baseline.
#>

Configuration Example
{
    param(
        [Parameter(Mandatory = $true)]
        [PSCredential]
        $credsGlobalAdmin
    )
    Import-DscResource -ModuleName Microsoft365DSC

    node localhost
    {
        EXOMalwareFilterPolicy 'ConfigureMalwareFilterPolicy'
        {
            Identity                               = "Default"
            Action                                 = "DeleteMessage"
            CustomNotifications                    = $False
            EnableExternalSenderAdminNotifications = $False
            EnableExternalSenderNotifications      = $False
            EnableFileFilter                       = $False
            EnableInternalSenderAdminNotifications = $False
            EnableInternalSenderNotifications      = $False
            FileTypes                              = @("ace", "ani", "app", "cab", "docm", "exe", "iso", "jar", "jnlp", "reg", "scr", "vbe", "vbs")
            ZapEnabled                             = $True
            Ensure                                 = "Present"
            Credential                             = $credsGlobalAdmin
        }
    }
}
